diff -ruN wt-4.3.1/src/Wt/Dbo/collection_impl.h wt-4.3.1-patch/src/Wt/Dbo/collection_impl.h
--- wt-4.3.1/src/Wt/Dbo/collection_impl.h	2020-04-20 18:06:51.000000000 +0100
+++ wt-4.3.1-patch/src/Wt/Dbo/collection_impl.h	2020-10-22 15:55:34.083635600 +0100
@@ -20,7 +20,7 @@
       template <class C>
       struct Helper {
 	static void skipIfRemoved
-	(typename collection<C>::iterator::shared_impl& it)
+        (typename collection<C>::iterator::shared_impl& /*it*/)
 	{ }
       };
 
diff -ruN wt-4.3.1/src/Wt/Dbo/DbAction_impl.h wt-4.3.1-patch/src/Wt/Dbo/DbAction_impl.h
--- wt-4.3.1/src/Wt/Dbo/DbAction_impl.h	2020-04-20 18:06:51.000000000 +0100
+++ wt-4.3.1-patch/src/Wt/Dbo/DbAction_impl.h	2020-10-22 15:55:34.084663200 +0100
@@ -349,14 +349,14 @@
 }
 
 template<typename V>
-void SaveBaseAction::actId(V& value, const std::string& name, int size)
+void SaveBaseAction::actId(V& /*value*/, const std::string& /*name*/, int /*size*/)
 {
   /* Only used from within visitAuxIds() */
 }
 
 template<class D>
-void SaveBaseAction::actId(ptr<D>& value, const std::string& name, int size,
-			   int fkConstraints)
+void SaveBaseAction::actId(ptr<D>& /*value*/, const std::string& /*name*/, int /*size*/,
+                           int /*fkConstraints*/)
 { 
   /* Only used from within visitAuxIds() */
 }
diff -ruN wt-4.3.1/src/Wt/Dbo/ptr_tuple.h wt-4.3.1-patch/src/Wt/Dbo/ptr_tuple.h
--- wt-4.3.1/src/Wt/Dbo/ptr_tuple.h	2020-04-20 18:06:51.000000000 +0100
+++ wt-4.3.1-patch/src/Wt/Dbo/ptr_tuple.h	2020-10-22 15:55:34.085397400 +0100
@@ -80,28 +80,28 @@
   struct helper<-1, Ts...>
   {
     typedef typename std::tuple<Ts...> TupleType;
-    static void getFields(Session& session,
-			  std::vector<std::string> *aliases,
-			  std::vector<FieldInfo>& result)
+    static void getFields(Session& /*session*/,
+                          std::vector<std::string> */*aliases*/,
+                          std::vector<FieldInfo>& /*result*/)
     { }
 
-    static void load(Session& session, SqlStatement& statement,
-		     int& column, TupleType& result)
+    static void load(Session& /*session*/, SqlStatement& /*statement*/,
+                     int& /*column*/, TupleType& /*result*/)
     { }
 
-    static void getValues(const TupleType& result, std::vector<cpp17::any>& values)
+    static void getValues(const TupleType& /*result*/, std::vector<cpp17::any>& /*values*/)
     { }
 
-    static void setValue(TupleType& result, int& index, const cpp17::any& value)
+    static void setValue(TupleType& /*result*/, int& /*index*/, const cpp17::any& /*value*/)
     { }
 
-    static void create(TupleType& result)
+    static void create(TupleType& /*result*/)
     { }
 
-    static void add(Session& session, TupleType& result)
+    static void add(Session& /*session*/, TupleType& /*result*/)
     { }
 
-    static void remove(TupleType& result)
+    static void remove(TupleType& /*result*/)
     { }
   };
 
@@ -185,14 +185,14 @@
 }
 
 template <typename... T>
-long long query_result_traits<std::tuple<T...>>::id(const std::tuple<T...>& t)
+long long query_result_traits<std::tuple<T...>>::id(const std::tuple<T...>& /*t*/)
 {
   return -1;
 }
 
 template <typename... T>
 std::tuple<T...> query_result_traits<std::tuple<T...>>
-::findById(Session& session, long long id)
+::findById(Session& /*session*/, long long /*id*/)
 {
   return std::tuple<T...>();
 }
diff -ruN wt-4.3.1/src/Wt/Dbo/SqlTraits_impl.h wt-4.3.1-patch/src/Wt/Dbo/SqlTraits_impl.h
--- wt-4.3.1/src/Wt/Dbo/SqlTraits_impl.h	2020-04-20 18:06:51.000000000 +0100
+++ wt-4.3.1-patch/src/Wt/Dbo/SqlTraits_impl.h	2020-10-22 15:55:34.086091900 +0100
@@ -20,7 +20,7 @@
 }
 
 template <typename Result>
-void query_result_traits<Result>::getFields(Session& session,
+void query_result_traits<Result>::getFields(Session& /*session*/,
 					  std::vector<std::string> *aliases,
 					  std::vector<FieldInfo>& result)
 {
@@ -44,7 +44,7 @@
 }
 
 template <typename Result>
-Result query_result_traits<Result>::load(Session& session,
+Result query_result_traits<Result>::load(Session& /*session*/,
 					 SqlStatement& statement,
 					 int& column)
 {
@@ -76,23 +76,23 @@
 }
 
 template <typename Result>
-void query_result_traits<Result>::add(Session& session, Result& result)
+void query_result_traits<Result>::add(Session& /*session*/, Result& /*result*/)
 {
 }
 
 template <typename Result>
-void query_result_traits<Result>::remove(Result& result)
+void query_result_traits<Result>::remove(Result& /*result*/)
 {
 }
 
 template <typename Result>
-long long query_result_traits<Result>::id(const Result& result)
+long long query_result_traits<Result>::id(const Result& /*result*/)
 {
   return -1;
 }
 
 template <typename Result>
-Result query_result_traits<Result>::findById(Session& session, long long id)
+Result query_result_traits<Result>::findById(Session& /*session*/, long long /*id*/)
 {
   return Result();
 }